----------------------------------
-- ADDON MANAGER 2D BY ENGIN33R --
--     ALL RIGHTS RESERVED      --
----------------------------------

----------------------------------
--         DEPENDENCIES         --
----------------------------------

dofile("sys/addonmanager.cfg")

modules_path="sys/lua/modules"

dofile("sys/lua/elib.lua")

package.cpath=cs2d_path.."\\sys\\core\\lfs.dll"
require "lfs"

-----------------------------------

function dirtree(dir) --Returns list of directory contents
	assert(dir and dir ~= "", "directory parameter is missing or empty")
	if string.sub(dir, -1) == "/" then
		dir=string.sub(dir, 1, -2)
	end

	local function yieldtree(dir)
	for entry in lfs.dir(dir) do
		if entry ~= "." and entry ~= ".." then
			entry=dir.."/"..entry
			local attr=lfs.attributes(entry)
			coroutine.yield(entry,attr)
				if attr.mode == "directory" then
					yieldtree(entry)
				end
			end
		end
	end

	return coroutine.wrap(function() yieldtree(dir) end)
end

function addEvent(event,func)
	if (_G[func]) then
		table.insert(functions[event],func)
		print("000255000Addon Manager 2D: event '"..event.."' added to function '"..func.."'")
	else
		print("255000000Addon Manager 2D ERROR: function does not exist ('"..func.."')")
	end
end

functions={}

function initfuncs(modulename)
	if (_G[modulename]) then
		for k,v in pairs(_G[modulename]) do
			if (type(v)=="function") then
				if (functions[tostring(k)]) then
					table.insert(functions[tostring(k)],v)
				else
					functions[tostring(k)]={}
					table.insert(functions[tostring(k)],v)
				end
				addhook(tostring(k),modulename.."."..k)
			end
		end
	end
end

for filename, _ in dirtree(modules_path) do
	if (filename:sub(-4)==".lua") then
		local p=modules_path:len()
		local mname=filename:sub(p+2)
		local fname=mname:sub(mname:find("/")+1,-5)
		print("115110252Addon Manager 2D: executing "..mname.."...")
		dofile(filename)
		initfuncs(fname)
		print("115110252Addon Manager 2D: "..mname.." executed successfully!")
	end
end
