admin={}

admin.users={}
admin.commands={}
admin.groups={}

admin.usersfile="sys/lua/modules/admin/users.am"
admin.groupsfile="sys/lua/modules/admin/groups.am"
admin.commandsfile="sys/lua/modules/admin/commands.am"

function loadgroups()
	dofile(admin.groupsfile)
	admin.groups=groups
end

function loadusers()
	dofile(admin.usersfile)
	admin.users=users
end

function saveusers()
	local file=assert(io.open(admin.usersfile,"w"))
	file:write("users = {\n")
	for k,v in pairs(admin.users) do
		file:write("	["..k.."] = {\n")
		file:write("		group = \""..admin.users[k].group.."\",\n")
		file:write("	},\n")
	end
	file:write("}\n")
	file:close()
end

function loadcommands()
	dofile(admin.commandsfile)
	admin.commands=commands
end

loadgroups()
loadusers()
loadcommands()

function admin.startround()
	loadgroups()
	loadusers()
	loadcommands()
end

function admin.say(ply,txt)
	local text=elib.eliminate(elib.eliminate(elib.split(txt,"(%w*)")," "),"")
	if (txt:sub(1,1)=="#") then
		local command=text[1]
		if (admin.groups[admin.users[player(ply,"usgn")].group].priority>=admin.groups[admin.commands[command].perm].priority) then
			if (command=="kick") then
				local pid=tonumber(text[2])
				local reason=txt:sub(command:len()+text[2]:len()+4)
				if (reason) then
					parse("kick "..pid.." \""..reason.."\"")
				else
					parse("kick "..pid)
				end
			elseif (command=="banusgn") then
				local pid=tonumber(text[2])
				local dur=tonumber(text[3])
				if (pid~=player(ply,"usgn")) then
					if (dur) then
						parse("banusgn "..pid.." "..dur)
					else
						parse("banusgn "..pid)
					end
				end
			elseif (command=="promote") then
				local pid=tonumber(text[2])
				local pgroup=text[3]
				if (pid~=ply and pid~=player(ply,"usgn") and admin.groups[pgroup].priority<admin.groups[admin.users[player(ply,"usgn")].group].priority) then
					if (player(pid,"exists")) then
						admin.users[player(pid,"usgn")].group=pgroup
						saveusers()
						msg2(ply,"Player "..player(pid,"name").." has been promoted to "..pgroup)
					else
						admin.users[pid].group=pgroup
						saveusers()
						msg2(ply,"Player ID #"..pid.." not found!")
						msg2(ply,"Player with USGN #"..pid.." has been promoted to "..pgroup)
					end
				end
			elseif (command=="speed") then
				local pid=tonumber(text[2])
				local spd=tonumber(txt:sub(command:len()+text[2]:len()+4))
				parse("speedmod "..pid.." "..spd)
			elseif (command=="health") then
				local pid=tonumber(text[2])
				local hp=tonumber(text[3])
				if (hp>player(pid,"maxhealth")) then
					parse("setmaxhealth "..pid.." "..hp)
				else
					parse("sethealth "..pid.." "..hp)
				end
			else
				msg2(ply,"Unknown command: "..command)
			end
		end
		return 1
	end
end
